from keras.utils import plot_model
import sys, numpy as np
from IPython.display import SVG
from keras.utils.vis_utils import model_to_dot

from sklearn.datasets import load_iris
# Lade Dateien
iris_dataset = load_iris()
X = iris_dataset['data']
y = iris_dataset['target']

print('Features: {}'.format(X.shape))
print('Ausgabe {}'.format(y.shape))

for ex_x, ex_y in zip(X[:10], y[:10]):
    print('{} -> {}'.format(ex_x, ex_y))

# Erstelle ein One-Hot-Encoding (https://machinelearningmastery.com/how-to-one-hot-encode-sequence-data-in-python/)
from sklearn.preprocessing import OneHotEncoder
onehot_encoder = OneHotEncoder(sparse=False, categories='auto')
y = y.reshape(len(y), 1)
y = onehot_encoder.fit_transform(y)

from sklearn.utils import shuffle
X_shuffled, y_shuffled = shuffle(X, y, random_state=0)
for ex_x, ex_y in zip(X_shuffled[:10], y_shuffled[:10]):
    print('{} -> {}'.format(ex_x, ex_y))

from sklearn.model_selection import train_test_split
X_train, X_test, y_train, y_test = train_test_split(X_shuffled, y_shuffled, random_state=0, train_size=0.3)
print("Features Training Shape: {}".format(X_train.shape))
print("Features Test Shape: {}".format(X_test.shape))

# Erstelle ein FF-Modell
from myModels import FeedForward
model = FeedForward(4)
model.train(X_train, y_train, X_test, y_test)
model.evaluate(X_test, y_test)
# plot_model(model.model, to_file='model.png')
# SVG(model_to_dot(model.model).create(prog='dot', format='svg'))

# Erstellung eines Graphen für die Auswertung
from Graphs import ComparisonGraph
import matplotlib.pyplot as plt
call = model.callback
acc_graph = ComparisonGraph(len(call.acc), call.loss, call.val_loss, call.acc, call.val_acc)
acc_graph.draw()

# Predictions
pred_amount = 10
print(">> Nutze die Test-Daten, um {} Predictions zu machen".format(pred_amount))
predictions = model.predict(X_test[:pred_amount])
for x, p, g in zip(X_test, predictions, y_test):
    pred = np.argmax(p)
    gold = np.argmax(g)
    print("{} --> {} [{}] (gold: {} [{}])".format(x, pred, iris_dataset['target_names'][pred], gold, iris_dataset['target_names'][gold]))